package com.malk.ruisi.controller;

/**
 * 错误抛出与拦截详见 CatchException
 */

import com.alibaba.fastjson.JSONObject;
import com.malk.ruisi.service.RSService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilMap;
import com.malk.utils.UtilServlet;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;
import java.util.Map;

@Slf4j
@RestController
@RequestMapping("dd")
public class DDController {

    @Autowired
    private RSService rsService;

    /**
     * 创建投资人用户
     */
    @PostMapping("user/sync")
    McR syncUser() {

        log.info("syncUser");
        rsService.syncDingTalk_exclusive();
        return McR.success();
    }

    /**
     * 重置密码流程
     */
    @PostMapping("reset")
    McR resetPwd(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("reset, {}", data);

        McException.assertParamException_Null(data, "userId", "password");
        rsService.resetPwd(data);
        return McR.success();
    }


    @Autowired
    private YDClient ydClient;

    @GetMapping("test")
    McR test() {

        ydClient.operateData(YDParam.builder()
                .formInstanceId("cc8b3153-3950-4fa5-b089-b28d1025ea7e")
                .updateFormDataJson(JSONObject.toJSONString(UtilMap.map("departmentSelectField_lys0k6qb", Arrays.asList("155254332"))))
                .useLatestVersion(true)
                .build(), YDConf.FORM_OPERATION.update);

        return McR.success();
    }
}
